POST
/v1/organizations/{organizationId}/projects/{projectId}/agent-definitions/{agentDefinitionId}/versionsPublish an immutable Agent Version
Create the next immutable Version in the Agent Definition lineage, or return the same Version when an identical request identifier is retried.
Authentication
Send an API key as a Bearer token in the Authorization header.
Parameters
Request body
Required.
application/jsonobject- unknown properties allowed
false
requestIdrequiredstringThe idempotency key for this exact publication.- maximum length
200 - minimum length
1
- maximum length
manifestrequired- AgentVersionManifestInputThe complete immutable Agent behavior and execution-budget declaration.
Publish the first immutable Agent Version
{
"requestId": "getting-started-version-1",
"manifest": {
"schemaVersion": "config.cantora.ai/agent-version/v1alpha2",
"instructions": "Answer support questions using the approved knowledge sources and cite the evidence used.",
"model": {
"provider": "googleVertex",
"model": "gemini-3.6-flash",
"settings": {
"thinkingLevel": "low"
}
},
"tools": [],
"requiredBindings": [],
"budgets": {
"maxModelSteps": 12,
"maxToolCalls": 0,
"totalWallTimeMs": 240000,
"modelStepTimeMs": 90000,
"streamStallTimeMs": 15000,
"maxInputTokens": 250000,
"maxOutputTokens": 16000,
"maxReasoningTokens": 32000,
"maxTotalTokens": 300000,
"maxToolResultBytes": 1000000,
"maxEstimatedCostMicros": 5000000
}
}
}Responses
200PublishedAgentVersionapplication/jsonAgent Version published
{
"outcome": "created",
"version": {
"agentVersionId": "agent_version_00000000000000000000000000000001",
"organizationId": "org_00000000000000000000000000000002",
"projectId": "proj_00000000000000000000000000000001",
"agentDefinitionId": "agentdef_00000000000000000000000000000001",
"revision": 1,
"manifest": {
"schemaVersion": "config.cantora.ai/agent-version/v1alpha2",
"instructions": "Answer support questions using the approved knowledge sources and cite the evidence used.",
"model": {
"provider": "googleVertex",
"model": "gemini-3.6-flash",
"settings": {
"thinkingLevel": "low"
}
},
"tools": [],
"requiredBindings": [],
"budgets": {
"maxModelSteps": 12,
"maxToolCalls": 0,
"totalWallTimeMs": 240000,
"modelStepTimeMs": 90000,
"streamStallTimeMs": 15000,
"maxInputTokens": 250000,
"maxOutputTokens": 16000,
"maxReasoningTokens": 32000,
"maxTotalTokens": 300000,
"maxToolResultBytes": 1000000,
"maxEstimatedCostMicros": 5000000
}
},
"manifestDigest": "bd4a4a3f62d50baff4d25163a924ed7eca49846b98eead984a1486fd80e36562",
"createdByPrincipalId": "principal_00000000000000000000000000000002",
"createdAt": "2026-01-15T18:30:00.000Z"
}
}400The request path, headers, query, or JSON body did not satisfy the published schema401Unauthorizedapplication/json403Forbiddenapplication/json404NotFoundapplication/json409Conflictapplication/jsonReusable schemas
PublishedAgentVersionEncoded
object- unknown properties allowed
false
outcomerequiredstringWhether publication created a new Agent Version or reused identical content.- allowed values
"created", "reused"
- allowed values
versionrequired- AgentVersionEncodedThe immutable Agent Version returned by the publication.
UnauthorizedEncoded
object- unknown properties allowed
false
_tagrequiredstringThe stable machine-readable error type.- allowed values
"Unauthorized"
- allowed values
reasonrequiredstringA safe explanation of why the credential was rejected.
ForbiddenEncoded
object- unknown properties allowed
false
_tagrequiredstringThe stable machine-readable error type.- allowed values
"Forbidden"
- allowed values
permissionrequiredstringThe permission required by the refused operation.
NotFoundEncoded
object- unknown properties allowed
false
_tagrequiredstringThe stable machine-readable error type.- allowed values
"NotFound"
- allowed values
resourcerequiredstringThe resource type relevant to the error.idrequiredstringThe identifier supplied for the resource that was not found.
ConflictEncoded
object- unknown properties allowed
false
_tagrequiredstringThe stable machine-readable error type.- allowed values
"Conflict"
- allowed values
resourcerequiredstringThe resource type relevant to the error.reasonrequiredstringA safe explanation of the state conflict.
AgentVersionManifestInput
AgentVersionEncoded
object- unknown properties allowed
false
agentVersionIdrequiredstringThe immutable Agent Version identifier.- maximum length
64 - pattern
^agent_version_[\s\S]+$
- maximum length
organizationIdrequiredstringThe Organization identifier.- maximum length
64 - pattern
^org_[\s\S]+$
- maximum length
projectIdrequiredstringThe Project identifier.- maximum length
64 - pattern
^proj_[\s\S]+$
- maximum length
agentDefinitionIdrequiredstringThe Agent Definition identifier.- maximum length
64 - pattern
^agentdef_[\s\S]+$
- maximum length
revisionrequiredintegerThe monotonically increasing revision within the Agent Definition.- greater than
0
- greater than
manifestrequired- AgentVersionManifestThe complete immutable Agent behavior and execution-budget declaration.
manifestDigestrequiredstringThe lowercase SHA-256 digest of the normalized manifest.- maximum length
64 - minimum length
64 - pattern
^[0-9a-f]{64}$
- maximum length
createdByPrincipalIdrequiredstringThe Principal that created this immutable record.- maximum length
64 - pattern
^principal_[\s\S]+$
- maximum length
createdAtrequiredstringWhen the resource was created, in UTC.- format
date-time
- format
AgentVersionManifestInputV1Alpha2
object- unknown properties allowed
false
schemaVersionrequiredstringThe Agent Version manifest schema identifier.- allowed values
"config.cantora.ai/agent-version/v1alpha2"
- allowed values
instructionsrequiredstringThe complete natural-language instructions for the Agent Version.- maximum length
262144
- maximum length
modelrequired- AgentVersionModelThe exact provider model and behavior settings pinned by the Agent Version.
toolsrequired- LegacyAgentVersionToolsThe tool keys the Agent Version may call.
requiredBindingsrequired- AgentVersionDependenciesThe configuration bindings the Agent Version requires at runtime.
budgetsrequired- AgentVersionBudgetsInputThe finite execution limits enforced for the Agent Version.
AgentVersionManifestInputV1Alpha3
object- unknown properties allowed
false
schemaVersionrequiredstringThe Agent Version manifest schema identifier.- allowed values
"config.cantora.ai/agent-version/v1alpha3"
- allowed values
instructionsrequiredstringThe complete natural-language instructions for the Agent Version.- maximum length
262144
- maximum length
modelrequired- AgentVersionModelThe exact provider model and behavior settings pinned by the Agent Version.
toolsrequired- AgentVersionToolsThe tool keys the Agent Version may call.
requiredBindingsrequired- AgentVersionDependenciesThe configuration bindings the Agent Version requires at runtime.
integrationDependenciesrequiredarrayThe exact immutable Integration Versions and logical bindings this Agent Version requires.- at most items
16
- at most items
contextSnapshotModel- ContextSnapshotModelInputThe exact model used for Conversation history compaction. Omission resolves to the reviewed gpt-5.6-luna configuration.
budgetsrequired- AgentVersionBudgetsInputThe finite execution limits enforced for the Agent Version.
entrypointsarrayThe named host-started operations declared by this Agent Version.- at most items
16 - at least items
1
Items- at most items
AgentVersionManifest
AgentVersionModel
Any of
object- unknown properties allowed
false
providerrequiredstringThe model, Surface, or integration provider key.- allowed values
"googleVertex"
- allowed values
modelrequiredstringThe exact provider model and behavior settings pinned by the Agent Version.- maximum length
256 - minimum length
1
- maximum length
settingsrequired- GoogleVertexModelSettingsThe provider-native settings that change model behavior.
object- unknown properties allowed
false
providerrequiredstringThe model, Surface, or integration provider key.- allowed values
"openai"
- allowed values
modelrequiredstringThe exact provider model and behavior settings pinned by the Agent Version.- maximum length
256 - minimum length
1
- maximum length
settingsrequired- OpenAiModelSettingsThe provider-native settings that change model behavior.
LegacyAgentVersionTools
array- at most items
100 - unique items
true
Items
string- allowed values
"run_code", "search_knowledge"
AgentVersionDependencies
array- at most items
100 - unique items
true
Items
string- maximum length
100 - minimum length
1 - pattern
^[a-z][a-z0-9_]*$
AgentVersionBudgetsInput
object- unknown properties allowed
false
maxModelStepsrequiredintegerThe maximum number of model calls in one Run.- maximum
100 - minimum
1
- maximum
maxToolCallsrequiredintegerThe maximum number of tool calls in one Run.- maximum
100 - minimum
0
- maximum
totalWallTimeMsrequiredintegerThe maximum total Run duration in milliseconds.- maximum
300000 - minimum
1000
- maximum
modelStepTimeMsrequiredintegerThe maximum duration of one model step in milliseconds.- maximum
300000 - minimum
1000
- maximum
streamStallTimeMsrequiredintegerThe maximum duration without stream progress in milliseconds.- maximum
300000 - minimum
1000
- maximum
maxInputTokensintegerThe maximum number of model input tokens. Omission resolves to 250,000.- maximum
10000000 - minimum
1
- maximum
maxOutputTokensrequiredintegerThe maximum number of model output tokens.- maximum
1000000 - minimum
1
- maximum
maxReasoningTokensrequiredintegerThe maximum number of model reasoning tokens.- maximum
1000000 - minimum
0
- maximum
maxTotalTokensrequiredintegerThe maximum total model tokens in one Run.- maximum
10000000 - minimum
1
- maximum
maxToolResultBytesrequiredintegerThe maximum aggregate tool-result size in bytes.- maximum
10000000 - minimum
1
- maximum
maxEstimatedCostMicrosrequiredintegerThe maximum estimated model cost in millionths of the billing currency.- maximum
1000000000 - minimum
1
- maximum
AgentVersionTools
AgentVersionIntegrationDependency
object- unknown properties allowed
false
bindingNamerequiredstringThe logical Environment binding name requested by the Agent Version.- maximum length
100 - minimum length
1 - pattern
^[a-z][a-z0-9_]*$
- maximum length
integrationIdrequiredstringThe stable Organization-scoped Integration identifier.- maximum length
64 - pattern
^integration_[\s\S]+$
- maximum length
integrationVersionIdrequiredstringThe immutable Integration Version identifier.- maximum length
64 - pattern
^integration_version_[\s\S]+$
- maximum length
integrationVersionDigestrequiredstringThe lowercase SHA-256 digest of the exact Integration Version manifest.- pattern
^[0-9a-f]{64}$
- pattern
requiredConnectionScoperequiredstringThe narrowest Connection scope this Agent dependency accepts.- allowed values
"tenant"
- allowed values
ContextSnapshotModelInput
Any of
object- unknown properties allowed
false
providerrequiredstringThe model, Surface, or integration provider key.- allowed values
"googleVertex"
- allowed values
modelrequiredstringThe exact provider model and behavior settings pinned by the Agent Version.- maximum length
256 - minimum length
1
- maximum length
settingsrequired- GoogleVertexModelSettingsThe provider-native settings that change model behavior.
object- unknown properties allowed
false
providerrequiredstringThe model, Surface, or integration provider key.- allowed values
"openai"
- allowed values
modelrequiredstringThe exact provider model and behavior settings pinned by the Agent Version.- maximum length
256 - minimum length
1
- maximum length
settingsrequired- OpenAiModelSettingsThe provider-native settings that change model behavior.
AgentEntrypointInput
object- unknown properties allowed
false
keyrequired- AgentEntrypointKeyThe stable, human-authored Agent Definition key.
purposerequiredstringA plain-language description of the work this entrypoint performs.- maximum length
500 - minimum length
1
- maximum length
openingInstructionrequiredstringThe fixed instruction that starts a Run admitted through this entrypoint.- maximum length
16384 - minimum length
1
- maximum length
acceptedTriggerKindsrequiredarrayThe Run trigger kinds allowed to select this entrypoint.- at least items
1 - unique items
true
- at least items
parametersrequiredarrayThe complete path, query, and header parameters for this operation.- at most items
32
- at most items
toolsrequired- AgentVersionToolsThe tool keys the Agent Version may call.
connectionBindingsrequired- AgentVersionDependenciesThe declared Connection bindings available to this entrypoint.
dataAccessrequiredstringWhether the entrypoint may use Tenant data alone or Tenant data plus an eligible User's data.- allowed values
"tenant", "tenantAndOptionalUser"
- allowed values
userAuthorityrequiredstringWhether a Run may receive authority for an eligible User through this entrypoint.- allowed values
"none", "optional"
- allowed values
effectsrequiredstringThe consequential external-effect authority available to this entrypoint.- allowed values
"none"
- allowed values
deliveryrequiredstringThe external Delivery authority available to this entrypoint.- allowed values
"none"
- allowed values
outputModerequiredstringWhether this entrypoint returns internal Run output or permits external presentation.- allowed values
"internalOnly"
- allowed values
resultrequired- AgentEntrypointResultThe strict result contract for this entrypoint.
budgetsrequired- AgentVersionBudgetsInputThe finite execution limits enforced for the Agent Version.
AgentVersionManifestV1Alpha2
object- unknown properties allowed
false
schemaVersionrequiredstringThe Agent Version manifest schema identifier.- allowed values
"config.cantora.ai/agent-version/v1alpha2"
- allowed values
instructionsrequiredstringThe complete natural-language instructions for the Agent Version.- maximum length
262144
- maximum length
modelrequired- AgentVersionModelThe exact provider model and behavior settings pinned by the Agent Version.
toolsrequired- LegacyAgentVersionToolsThe tool keys the Agent Version may call.
requiredBindingsrequired- AgentVersionDependenciesThe configuration bindings the Agent Version requires at runtime.
budgetsrequired- AgentVersionBudgetsThe finite execution limits enforced for the Agent Version.
AgentVersionManifestV1Alpha3
object- unknown properties allowed
false
schemaVersionrequiredstringThe Agent Version manifest schema identifier.- allowed values
"config.cantora.ai/agent-version/v1alpha3"
- allowed values
instructionsrequiredstringThe complete natural-language instructions for the Agent Version.- maximum length
262144
- maximum length
modelrequired- AgentVersionModelThe exact provider model and behavior settings pinned by the Agent Version.
toolsrequired- AgentVersionToolsThe tool keys the Agent Version may call.
requiredBindingsrequired- AgentVersionDependenciesThe configuration bindings the Agent Version requires at runtime.
integrationDependenciesrequiredarrayThe exact immutable Integration Versions and logical bindings this Agent Version requires.- at most items
16
- at most items
contextSnapshotModel- AgentVersionModelThe exact provider model and behavior settings used for Conversation history compaction.
budgetsrequired- AgentVersionBudgetsThe finite execution limits enforced for the Agent Version.
entrypointsarrayThe named host-started operations declared by this Agent Version.- at most items
16 - at least items
1
Items- at most items
GoogleVertexModelSettings
object- unknown properties allowed
false
thinkingLevelrequiredstringThe Google Vertex-native thinking level.- allowed values
"minimal", "low", "medium", "high"
- allowed values
OpenAiModelSettings
object- unknown properties allowed
false
reasoningEffortrequiredstringThe OpenAI-native reasoning effort.- allowed values
"none", "low", "medium", "high", "xhigh", "max"
- allowed values
reasoningModerequiredstringThe OpenAI-native reasoning mode.- allowed values
"standard", "pro"
- allowed values
AgentToolName
string- allowed values
"run_code", "search_knowledge", "search_api_reference", "propose_action"
AgentEntrypointKey
string- maximum length
100 - minimum length
1 - pattern
^[a-z][a-z0-9_]*$
AgentEntrypointTriggerKind
Any of
string- allowed values
"manual"
AgentEntrypointParameter
AgentEntrypointResult
object- unknown properties allowed
false
typerequiredstringThe closed contract behavior type.- allowed values
"text"
- allowed values
maximumBytesrequiredintegerThe greatest accepted UTF-8 result size in bytes.- maximum
1048576 - minimum
1
- maximum
allowsNoChangerequiredbooleanWhether the entrypoint may complete successfully without producing a result value.
AgentVersionBudgets
object- unknown properties allowed
false
maxModelStepsrequiredintegerThe maximum number of model calls in one Run.- maximum
100 - minimum
1
- maximum
maxToolCallsrequiredintegerThe maximum number of tool calls in one Run.- maximum
100 - minimum
0
- maximum
totalWallTimeMsrequiredintegerThe maximum total Run duration in milliseconds.- maximum
300000 - minimum
1000
- maximum
modelStepTimeMsrequiredintegerThe maximum duration of one model step in milliseconds.- maximum
300000 - minimum
1000
- maximum
streamStallTimeMsrequiredintegerThe maximum duration without stream progress in milliseconds.- maximum
300000 - minimum
1000
- maximum
maxInputTokensrequiredintegerThe maximum number of model input tokens recorded for this execution budget.- maximum
10000000 - minimum
1
- maximum
maxOutputTokensrequiredintegerThe maximum number of model output tokens.- maximum
1000000 - minimum
1
- maximum
maxReasoningTokensrequiredintegerThe maximum number of model reasoning tokens.- maximum
1000000 - minimum
0
- maximum
maxTotalTokensrequiredintegerThe maximum total model tokens in one Run.- maximum
10000000 - minimum
1
- maximum
maxToolResultBytesrequiredintegerThe maximum aggregate tool-result size in bytes.- maximum
10000000 - minimum
1
- maximum
maxEstimatedCostMicrosrequiredintegerThe maximum estimated model cost in millionths of the billing currency.- maximum
1000000000 - minimum
1
- maximum
AgentEntrypoint
object- unknown properties allowed
false
keyrequired- AgentEntrypointKeyThe stable entrypoint key within this Agent Version.
purposerequiredstringA plain-language description of the work this entrypoint performs.- maximum length
500 - minimum length
1
- maximum length
openingInstructionrequiredstringThe fixed instruction that starts a Run admitted through this entrypoint.- maximum length
16384 - minimum length
1
- maximum length
acceptedTriggerKindsrequiredarrayThe Run trigger kinds allowed to select this entrypoint.- at least items
1 - unique items
true
- at least items
parametersrequiredarrayThe complete set of strict top-level parameters accepted by this entrypoint.- at most items
32
- at most items
toolsrequired- AgentVersionToolsThe tool keys the Agent Version may call.
connectionBindingsrequired- AgentVersionDependenciesThe declared Connection bindings available to this entrypoint.
dataAccessrequiredstringWhether the entrypoint may use Tenant data alone or Tenant data plus an eligible User's data.- allowed values
"tenant", "tenantAndOptionalUser"
- allowed values
userAuthorityrequiredstringWhether a Run may receive authority for an eligible User through this entrypoint.- allowed values
"none", "optional"
- allowed values
effectsrequiredstringThe consequential external-effect authority available to this entrypoint.- allowed values
"none"
- allowed values
deliveryrequiredstringThe external Delivery authority available to this entrypoint.- allowed values
"none"
- allowed values
outputModerequiredstringWhether this entrypoint returns internal Run output or permits external presentation.- allowed values
"internalOnly"
- allowed values
resultrequired- AgentEntrypointResultThe strict result contract for this entrypoint.
budgetsrequired- AgentVersionBudgetsThe finite execution limits enforced for the Agent Version.
AgentEntrypointStringParameter
object- unknown properties allowed
false
keyrequired- AgentEntrypointKeyThe stable parameter key within this entrypoint.
descriptionrequiredstringA human-readable explanation of this contract element.- maximum length
500 - minimum length
1
- maximum length
requiredrequiredbooleanWhether the parameter must be present.typerequiredstringThe closed contract behavior type.- allowed values
"string"
- allowed values
minimumLengthrequiredintegerThe least accepted string length.- maximum
65536 - minimum
0
- maximum
maximumLengthrequiredintegerThe greatest accepted string length.- maximum
65536 - minimum
1
- maximum
AgentEntrypointIntegerParameter
object- unknown properties allowed
false
keyrequired- AgentEntrypointKeyThe stable parameter key within this entrypoint.
descriptionrequiredstringA human-readable explanation of this contract element.- maximum length
500 - minimum length
1
- maximum length
requiredrequiredbooleanWhether the parameter must be present.typerequiredstringThe closed contract behavior type.- allowed values
"integer"
- allowed values
minimumrequiredintegerThe least accepted numeric value.maximumrequiredintegerThe greatest accepted numeric value.
AgentEntrypointNumberParameter
object- unknown properties allowed
false
keyrequired- AgentEntrypointKeyThe stable parameter key within this entrypoint.
descriptionrequiredstringA human-readable explanation of this contract element.- maximum length
500 - minimum length
1
- maximum length
requiredrequiredbooleanWhether the parameter must be present.typerequiredstringThe closed contract behavior type.- allowed values
"number"
- allowed values
minimumrequirednumberThe least accepted numeric value.maximumrequirednumberThe greatest accepted numeric value.
AgentEntrypointBooleanParameter
object- unknown properties allowed
false
keyrequired- AgentEntrypointKeyThe stable parameter key within this entrypoint.
descriptionrequiredstringA human-readable explanation of this contract element.- maximum length
500 - minimum length
1
- maximum length
requiredrequiredbooleanWhether the parameter must be present.typerequiredstringThe closed contract behavior type.- allowed values
"boolean"
- allowed values
AgentEntrypointStringListParameter
object- unknown properties allowed
false
keyrequired- AgentEntrypointKeyThe stable parameter key within this entrypoint.
descriptionrequiredstringA human-readable explanation of this contract element.- maximum length
500 - minimum length
1
- maximum length
requiredrequiredbooleanWhether the parameter must be present.typerequiredstringThe closed contract behavior type.- allowed values
"stringList"
- allowed values
minimumItemsrequiredintegerThe least accepted number of list items.- maximum
100 - minimum
0
- maximum
maximumItemsrequiredintegerThe greatest accepted number of list items.- maximum
100 - minimum
1
- maximum
minimumItemLengthrequiredintegerThe least accepted string length for one list item.- maximum
65536 - minimum
0
- maximum
maximumItemLengthrequiredintegerThe greatest accepted string length for one list item.- maximum
65536 - minimum
1
- maximum